Imports System.IO
Imports System.Collections.Specialized 'For NameValueCollection
Imports System.Net.WebClient
Imports System.Web

Public Class Form1

    Private Sub btn_Reap_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Reap.Click


        If txtStartURL.Text <> "" Then

            If Get_DomainName(txtStartURL.Text) <> "Nothing" Then

                lstReapedLinks.Items.Clear()

                Dim _htmlCode As String = Get_HtmlCode(txtStartURL.Text)
                Get_All_Links(txtStartURL.Text, _htmlCode)

                MsgBox("Total Links Reaped: " & lstReapedLinks.Items.Count)
            Else
                MsgBox("Please enter a Valid URL!!  eg: http://www.google.com", MsgBoxStyle.Exclamation, "Invalid URL")
            End If




        Else
            MsgBox("Please enter the URL")
            txtStartURL.Focus()
        End If

    End Sub


    Public Sub Get_All_Links(ByVal _URL As String, ByVal _htmlCode As String)

        Dim _LinkCnt As Integer = 1



        Dim _startStr As String

        Dim _startStrA(4) As String
        _startStrA(1) = "<a href="""
        _startStrA(2) = "<a href=/"
        _startStrA(3) = "<a href=h"

        Dim x As Integer
        For x = 1 To 3

            _startStr = _startStrA(x)

            Dim _endStr As String = """"
            Dim _tmpStr As String = ""
            Dim _2ndPart As String = ""

            Dim i, j, k As Integer

            k = 1

            For i = k To Len(_htmlCode)

                _tmpStr = Mid$(_htmlCode, i, Len(_startStr))
                If _tmpStr = _startStr Then

                    For j = (i + Len(_startStr)) To Len(_htmlCode)

                        _tmpStr = Mid$(_htmlCode, j, Len(_endStr))
                        If _tmpStr = _endStr Or _tmpStr = ">" Then

                            _2ndPart = Mid$(_htmlCode, (i + Len(_startStr)), (j - (i + Len(_startStr))))

                            lstReapedLinks.Items.Add(Get_FullLink(_URL, _2ndPart)) 'Full Link

                            _LinkCnt = _LinkCnt + 1

                            i = j
                            GoTo lbl

                        End If

                    Next

                End If
lbl:

            Next


        Next

    End Sub

    Private Function Get_FullLink(ByVal _URL As String, ByVal _2ndPart As String) As String

        Dim DotDotSlash_cnt As Integer
        Dim _FullLink As String = ""

        Dim _DomainName As String = Get_DomainName(_URL)

        'If (Is_DirectLink(_2ndPart)) Then       'http://www.domain.com/page1/SubPage1.html
        If Mid$(_2ndPart, 1, 7) = "http://" Then
            _FullLink = _2ndPart 'lstReapedLinks.Items.Add(_2ndPart)
        ElseIf Mid$(_2ndPart, 1, 8) = "https://" Then
            _FullLink = _2ndPart 'lstReapedLinks.Items.Add(_2ndPart)
        ElseIf Mid$(_2ndPart, 1, 6) = "ttp://" Then
            _FullLink = "h" & _2ndPart
            'End If
        Else                                    'page1/SubPage1.html (or) ../page1/SubPage1.html
            DotDotSlash_cnt = Get_DotDotSlash_Count(_2ndPart)
            If DotDotSlash_cnt > 1 Then         '../page1/SubPage1.html
                _FullLink = Get_n_DirBack(DotDotSlash_cnt, _URL) & (_2ndPart.Replace("../", "")) 'lstReapedLinks.Items.Add(Get_n_DirBack(DotDotSlash_cnt, _PageLink) & (_2ndPart.Replace("../", "")))
            Else                                'page1/SubPage1.html (or) /page1/SubPage1.html
                If (_URL = _DomainName) Then 'if links are from Start Page
                    If StartSlash(_2ndPart) Then
                        _FullLink = _DomainName & _2ndPart '/page1/SubPage1.html
                    Else
                        _FullLink = _DomainName & "/" & _2ndPart 'page1/SubPage1.html
                    End If
                Else 'if links are from Sub Pages
                    _FullLink = Get_n_DirBack(1, _URL) & _2ndPart 'lstReapedLinks.Items.Add(Get_n_DirBack(1, _PageLink) & _2ndPart)
                End If
            End If
        End If

        Return _FullLink
    End Function

    Public Function Get_DomainName(ByVal _URL As String) As String

        Dim _DomainName As String = "Nothing"

        Try
            Dim _URI As System.Uri = New System.Uri(_URL)

            If Mid$(_URL, 1, 8) = "https://" Then
                _DomainName = "https://" & _URI.Host
            Else
                _DomainName = "http://" & _URI.Host
            End If

            Return _DomainName

        Catch ex As Exception

            _DomainName = "Nothing"
            Return _DomainName

        End Try



    End Function

    Private Function Get_DotDotSlash_Count(ByVal _2ndPart As String) As Integer

        Dim i As Integer
        Dim DotSlash_cnt As Integer = 0

        For i = 1 To Len(_2ndPart)

            If Mid$(_2ndPart, i, 3) = "../" Then
                DotSlash_cnt = DotSlash_cnt + 1
            End If

        Next '----> to calculate the Number of ../

        Return (DotSlash_cnt + 1)

    End Function

    Private Function Get_n_DirBack(ByVal n As Integer, ByVal _URL As String) As String

        Dim _Ptr, i As Integer
        Dim _SlashLocs(50) As Integer

        i = 0

        For _Ptr = 1 To Len(_URL)

            If Mid$(_URL, _Ptr, 1) = "/" Then
                i = i + 1
                _SlashLocs(i) = _Ptr
                _SlashLocs(0) = i
            End If

        Next '----> to calculate the Number of slashes


        Dim _SlashCnt As Integer = _SlashLocs(0)

        Dim _LastSlash As Integer = _SlashLocs(_SlashCnt - (n - 1))


        Return Mid$(_URL, 1, _LastSlash)

    End Function

    Private Function StartSlash(ByVal _2ndPart As String) As Boolean
        If Mid$(_2ndPart, 1, 1) = "/" Then
            Return True
        Else
            Return False
        End If
    End Function

    Public Function Get_HtmlCode(ByVal _URL As String) As String

        Dim _HtmlCode As String = "Nothing"
        Dim _WebClient As System.Net.WebClient = New System.Net.WebClient()
        Dim _HtmlStream As System.IO.Stream


        Try
            _HtmlStream = _WebClient.OpenRead(_URL)

            Dim _HtmlStreamReader As System.IO.StreamReader = New System.IO.StreamReader(_HtmlStream)
            _HtmlCode = _HtmlStreamReader.ReadToEnd()

            Return _HtmlCode

        Catch ex As Exception
            Return _HtmlCode = "Nothing"
        End Try

    End Function



End Class
